<%@ page import="java.awt.*,java.awt.image.*,com.sun.image.codec.jpeg.*" %>
<%@ page contentType="image/jpeg" %>

<%
	// opret billede <title>Billede</title>
	BufferedImage billede = new BufferedImage(300, 100, BufferedImage.TYPE_INT_RGB);
	Graphics2D g = billede.createGraphics();

	//g.setRenderingHint( // st evt. tegnevink til trappeudjvning (antialias)
	//	RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

	// udfyld baggrund
	g.setColor(Color.white);
	g.fillRect(0,0,300, 100);

	// tegn ramme
	g.setColor(Color.red);
	g.drawRect(15, 15, 270, 70);

	// tegn nogle andre ting
	g.setColor(Color.black);
	g.fillOval(5,20,250,30);
	g.setColor(Color.green);
	g.drawLine(10,10,280,40);

	// skriv tekst, ud fra parameter eller sessionsattribut "billedtekst"
	String tekst = request.getParameter("billedtekst");
	if (tekst==null) tekst = (String) session.getAttribute("billedtekst");
	if (tekst==null) tekst = "Hej grafiske verden!"; // standardtekst
	g.drawString(tekst,50,40);

	// frdig med at tegne, frigiv grafik-objektet
	g.dispose();

	// og konvertr billede til JPG-format og send billedet
	ServletOutputStream sos = response.getOutputStream();
	JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(sos);

  // St kvaliteten af det genererede JPG-billede
  JPEGEncodeParam param = JPEGCodec.getDefaultJPEGEncodeParam(billede);
  param.setQuality(0.90f,false); // 0.75 er standardkvalitet
  encoder.setJPEGEncodeParam(param);

	encoder.encode(billede);
%>